package io.gitlab.jfronny.breakme;

import io.gitlab.jfronny.breakme.crash.Method;
import io.gitlab.jfronny.libjf.config.api.v1.*;

@JfConfig
public class BreakMeConfig {
    @Entry public static Cause event = Cause.Death;
    @Entry public static Method method = Method.Exception;

    public enum Cause {
        Damage,
        Death,

        All,
        None
    }

    @Verifier
    public static void validProvider() {
        if (BreakMeConfig.method == null) {
            BreakMeConfig.method = Method.None;
            BreakMe.LOGGER.error("Could not find specified crash provider, defaulting to None");
        }
    }

    static {
        JFC_BreakMeConfig.ensureInitialized();
    }
}
